package com.zipcodewilmington;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils
{
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array)

    {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array)

    {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array)
    {
        return array[array.length-1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array)
    {
        return array[array.length-2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value)
    {
        for(String str : array)
        {
            if(value.equals(str))
            {
                return true;
            }
        }
        return false;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO

    public static String[] reverse(String[] array)
    {
        String[] str = new String[array.length];
        int count=(array.length)-1;
        for(String s : array)
        {
            str[count]=s;
              count--;
        }
        return  str;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        String[] str = new String[array.length];
        int count = (array.length) - 1;
        for (String s : array) {
            str[count] = s;
            count--;
            for (int i = 0, j = 0; i < array.length; i++, j++) {
                if (array[i].equals(str[j]))
                    return true;
            }

        }
        return false;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array)
    {
        boolean isAPanGramic = true;
        String strLower = "";
        for (String var : array) {
            strLower = strLower.concat(var.toLowerCase());
        }
        for(int i = 97; i <= 122; i++){
            if(!strLower.contains(Character.toString((char)i))){
                isAPanGramic = false;
            }
        }
        return isAPanGramic;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value)
    {
        int count = 0;

        for (String str: array){
            if(value.equals(str) )
                count++;
        }
        return count;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove)
    {
        List<String> list = new ArrayList<String>(Arrays.asList(array));
        list.remove(valueToRemove);
        array = list.toArray(new String[0]);
        return array;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array)
    {

        ArrayList<String> remove = new ArrayList<String>();
        remove.add(array[0]);
        for (int i = 1; i < array.length; i++) {
            if (!array[i - 1].equals(array[i])) {
                remove.add(array[i]);
            }
        }
        String[] newArray = new String[remove.size()];
        newArray = remove.toArray(new String[remove.size()]);

        return newArray;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array)
    {

        ArrayList<String> arrayList = new ArrayList<String>();
        String str = new String();
        str = array[0];
        arrayList.add(array[0]);
        for (int i = 1; i < array.length; i++) {
            if (array[i] == str) {
                arrayList.set(arrayList.size() - 1, arrayList.get(arrayList.size() - 1) + array[i]);
            } else {
                arrayList.add(array[i]);
                str = array[i];
            }
        }
        String[] newArray = new String[arrayList.size()];
        newArray = arrayList.toArray(new String[arrayList.size()]);
        return newArray;
    }


}
